#==============================================================================#
#                        Copyright 2022-2024 ArchaicSoft                       #
#                                                                              #
# Boost Software License - Version 1.0 - August 17th, 2003                     #
#                                                                              #
# Permission is hereby granted, free of charge, to any person or organization  #
# obtaining a copy of the software and accompanying documentation covered by   #
# this license (the "Software") to use, reproduce, display, distribute,        #
# execute, and transmit the Software, and to prepare derivative works of the   #
# Software, and to permit third-parties to whom the Software is furnished to   #
# do so, all subject to the following:                                         #
#                                                                              #
# The copyright notices in the Software and this entire statement, including   #
# the above license grant, this restriction and the following disclaimer,      #
# must be included in all copies of the Software, in whole or in part, and     #
# all derivative works of the Software, unless such copies or derivative       #
# works are solely in the form of machine-executable object code generated by  #
# a source language processor.                                                 #
#                                                                              #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   #
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     #
# FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT    #
# SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE    #
# FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,  #
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER  #
# DEALINGS IN THE SOFTWARE.                                                    #
#==============================================================================#

@tool extends EditorPlugin

func _get_plugin_icon() -> Texture2D: return preload("icon.svg")

func _enter_tree() -> void: _guarentee_dependencies()

func _exit_tree() -> void: pass

func _guarentee_dependencies() -> void:
	# ensure forced objects exists
	var forced_path   : String = "res://addons/asfw/network_rdp/forced/"
	
	# ensure packets class file exists
	var found_class : bool
	for c in ProjectSettings.get_global_class_list():
		if c["class"] == "Packet":
			found_class = true
			break
	
	# create missing packets class file
	if not found_class:
		DirAccess.copy_absolute(forced_path + "packet.gdt", "res://packet.gd")
